//Dessine la bordure du jeu (et mme un peu plus que a)
void DessineBordure()		{
	int i;
	Sprite(0,0,8,8,sprBordure+8*8*3);
	Sprite(136,0,8,8,sprBordure+8*16*3);

	for (i=8;i<136;i+=8)
		Sprite(i,0,8,8,sprBordure+8*24*3);

	for (i=8;i<208;i+=8)		{
		Sprite(0,i,8,8,sprBordure);
		Sprite(136,i,8,8,sprBordure);
	}

	Sprite(32,166,68,42,sprBarreFond);

	TransCadre(8,164,128,1,RGB(0,255,0),192);
	TransCadre(8,165,128,1,RGB(0,128,0),192);
//	TransSprite(40,166,68,42,sprBarreFond,192);
}

void DessineDecorsBase()		{
	int i;
	//Le fond...
	WinOpen(bitsImage,0,15,LARG,HAUT);
	ColoreCadre(0,0,LARG,HAUT,RGB(0,0,128));

	//Dessine les pierres au fond
	for (i=0;i<320+32;i+=32)		{
		if (i<320)
			Sprite(i,208,32,8,sprPierre);
		SpriteRapide(i-16,216,32,8,sprPierre);
	}

	//Dessine le dgrad du score
	WinOpen(bitsImage,0,0,LARG,15);
	for (i=0;i<15;i+=1)
		ColoreCadre(0,i,LARG,1,RGB(0,0,(17*i)/2));
}

//Dessine un canon. L'eussiez-vous cru?
void DessineCanon(CANON *canon)		{
	int px=(int)(20.0*cos((double)((canon->angle*PI)/180.0)));
	int py=(int)(20.0*sin((double)((canon->angle*PI)/180.0)));
	int cx=(int)(25.0*cos((double)((canon->angle*PI)/180.0)));
	int cy=(int)(25.0*sin((double)((canon->angle*PI)/180.0)));
	int fx=(int)(8.0*cos((double)(((canon->angle-150)*PI)/180.0)));
	int fy=(int)(8.0*sin((double)(((canon->angle-150)*PI)/180.0)));
	int f2x=(int)(8.0*cos((double)(((canon->angle-210)*PI)/180.0)));
	int f2y=(int)(8.0*sin((double)(((canon->angle-210)*PI)/180.0)));

	SelectObject(hdcImage,hpenEpais);
	DessLigne(72,166+15,72+px,166+15-py);

//	DessLigne(79+px,166+15-py,79+px+fx,166+15-py-fy);
//	DessLigne(79+px,166+15-py,79+px+f2x,166+15-py-f2y);
//	DessLigne(79+px+fx,166+15-py-fy,79+px+f2x,166+15-py-f2y);

	SelectObject(hdcImage,hpenNormal);
	DessTriangle(72+cx,166+15-cy,72+cx+fx,166+15-cy-fy,72+cx+f2x,166+15-cy-f2y);

	if (canon->bulleChargee)
		Sprite(64,176,16,16,sprBulles+16*16*3*(canon->bulleChargee-1));

	TransSprite(16,192,16,16,sprBulles+16*16*3*(canon->prochBulle-1),192);
//	TransSprite(72,176,16,16,sprBulles+48*16*3,192);
}

//#define AFFICHE_ZONE_REACTIVE					//Pour le dboguage...

void DessineBulle(BULLE *bulle)		{
	if (bulle->couleur<1 || bulle->couleur>9 || !bulle->type)				//Boule non-valide!
		return;
	if (bulle->angle>180)
		CLIP_Y1=164+15;
	else
		CLIP_Y1=HAUT;

#ifdef AFFICHE_ZONE_REACTIVE
	if (bulle->type==LANCEE)		{
		int pY=((int)bulle->y-8)/14;
		int pX=((int)bulle->x-16)/8;
		int i,j;

		for (i=-1;i<=2;i++)
			for (j=-1;j<=1;j++)		{
				if ((j==-1 && ((int)bulle->y-8)%14>0) || (i==2 && ((int)bulle->x-24)%16==0))
					continue;
				TransCadre(16+8*(pX+i),8+14*(pY+j),8,14,RGB(0,255,255),128);
			}
	}
#endif
	Sprite((int)bulle->x,(int)bulle->y,16,16,sprBulles+16*16*3*(bulle->couleur-1));
}

void DessineBulles(BULLE *bulles)		{
	int i;
	for (i=0;bulles[i].type;i++)		{
		DessineBulle(&bulles[i]);
	}
	CLIP_Y1=HAUT;
}

//Dessine... (devinez quoi) ... le tableau du jeu!
void DessineTableau()		{
	BULLE bulleTemp;
	int i,j,k;

	if (modeJoueur[J]==MODEJ_NORMAL)		{
		if (nCoups[J]==8)
			CLIP_Y0=(nTrames%12==0)?17:15;
		else if (nCoups[J]==9)
			CLIP_Y0=(nTrames%6==0)?17:15;
	}

	for (j=0;j<13;j++)		{
		for (i=0;i<15;i++)		{
			if (map(i,j))		{
				bulleTemp.angle=0;
				bulleTemp.type=NORMALE;
				bulleTemp.couleur=map(i,j);
				bulleTemp.x=(float)(8.0+8.0*i);
				bulleTemp.y=(float)(8.0+14.0*j);
				DessineBulle(&bulleTemp);
				if (modeJoueur[J]==MODEJ_GAMEOVER)		{
//					k=10*tempsGameOver[J]-(12-j)*100;
					k=10*tempsGameOver[J]-100*j;
					if (k>255)
						k=255;

					if (k>0)
						TransSprite((int)bulleTemp.x,(int)bulleTemp.y,16,16,sprBulles+16*16*3*(BNOIRE-1),k);
				}
			}
		}
	}
}

void DessineTableauNB()		{
	int i,j;
	for (j=0;j<240;j++)
		for (i=0;i<320;i++)
			if (miniEcran[320*j+i])
				ColoreCadre(i,j,1,1,RGB(255,255,255));
}


//Dessine les bulles mortes (j'ai  peine l'impression de me rpter l :D)
void DessineBullesMortes(BULLEMORTE *bulleMortes)		{
	int i;

	for (i=0;i<nBullesMortes[J];i++)		{
		if (bullesMortes[J][i].type==FAMILLE)
			TransSprite(bullesMortes[J][i].x,bullesMortes[J][i].y,16,16,sprBulles+16*16*3*(bullesMortes[J][i].couleur-1),tempsBullesMortes[J]);
//			AdditionneSprite(bullesMortes[J][i].x,bullesMortes[J][i].y,16,16,sprBulles+16*16*3*(bullesMortes[J][i].couleur-1));
		else
			TransSprite(bullesMortes[J][i].x,bullesMortes[J][i].y,16,16,sprBulles+16*16*3*(bullesMortes[J][i].couleur-1),tempsBullesMortes[J]);
	}
}

//Arriverez-vous  deviner tout seul ce que peut bien faire cette fonction?
void DessineEcran()		{
	DessineDecorsBase();

	RegleJoueur(1);

	WinOpen(bitsImage,8,15,LARG,HAUT);

	DessineBordure();

	DessineTableau();
//	DessineTableauNB();

	DessineBulles(bulles[J]);

	DessineBullesMortes(bullesMortes[J]);

	CLIP_Y0=15;
	DessineCanon(&canonStd[J]);
	

	//Joueur 2
	RegleJoueur(2);

	WinOpen(bitsImage,168,15,LARG,HAUT);
	DessineBordure();
	DessineTableau();
	DessineBulles(bulles[J]);
	DessineBullesMortes(bullesMortes[J]);
	CLIP_Y0=15;
	DessineCanon(&canonStd[J]);


	SetTextColor(hdcImage,RGB(255,255,255));
	SetBkMode(hdcImage,TRANSPARENT);
	sprintf(str,"% 6i% 11i",nBulles[1],score[1]);
	DessTexte(174,1,str);
	sprintf(str,"% 6i% 11i",nBulles[0],score[0]);
	DessTexte(14,1,str);
	SetTextColor(hdcImage,RGB(255,255,0));
	SetBkMode(hdcImage,OPAQUE);
	SetBkColor(hdcImage,0);
	if (tempsJeu[0]/60<10)
		sprintf(str," %i%c%02i",tempsJeu[0]/60,(nTrames%50>=25)?' ':':',tempsJeu[0]%60);
	else if (tempsJeu[0]/60<100)
		sprintf(str,"%i%c%02i",tempsJeu[0]/60,(nTrames%50>=25)?' ':':',tempsJeu[0]%60);
	else if (tempsJeu[0]/60<10*60)
		sprintf(str," %ih%02i",(tempsJeu[0]/60)/60,(tempsJeu[0]/60)%60);
	else if (tempsJeu[0]/60<100*60)
		sprintf(str,"%ih%02i",(tempsJeu[0]/60)/60,(tempsJeu[0]/60)%60);
	else
		sprintf(str,"%03ijr",((tempsJeu[0]/60)/60)/24);
	DessTexte(280,226,str);
}
