#define ASSERT(condition)	if (!(condition))	  MessageBox(GetFocus(),"Erreur: "#condition,"Deception",0);
unsigned char *Bits;
#define LARG 320
#define HAUT 240
int CLIP_X0=0, CLIP_Y0=0, CLIP_X1=LARG, CLIP_Y1=HAUT;
#define LARG_BUF LARG
#define HAUT_BUF HAUT
#define WinOpen(image,x0,y0,x1,y1)		(Bits=image, CLIP_X0=x0, CLIP_Y0=y0, CLIP_X1=x1, CLIP_Y1=y1)

#define ClipSprite			{										\
							if (!Bits)	return;						\
							if (y0<0)	{							\
								sprite+=l*(0-y0)*3;					\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								a=-x0;								\
								sprite+=-x0*3;						\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								a=-(CLIP_X1-(x0+l));				\
								l-=a;								\
							}										\
							a*=3;									\
							if (h<0)	return;						\
							}

#define ClipRect			{										\
							if (!Bits)	return;						\
							if (y0<0)	{							\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								l+=CLIP_X1-(x0+l);					\
							}										\
							if (h<0)	return;						\
							}




void Create(HDC hdc, int cx, int cy, int ibitcount, HBITMAP *hbm, void **bits) 
{
   ASSERT((ibitcount == 8) || (ibitcount == 16) || (ibitcount = 24)) ;
   ASSERT(cx > 0);
   ASSERT(cy > 0);

   // Create a BITMAPINFOHEADER structure to describe the DIB.
   BITMAPINFOHEADER BIH ;
   int iSize = sizeof(BITMAPINFOHEADER);
   memset(&BIH, 0, iSize);

   // Fill in the header info. 
   BIH.biSize = iSize;
   BIH.biWidth = cx;
   BIH.biHeight = cy+1;
   BIH.biPlanes = 1;
   BIH.biBitCount = ibitcount;
   BIH.biCompression = BI_RGB;

   // Create a new device context.

   // Create the DIB section.
   *hbm = CreateDIBSection(hdc,
               (BITMAPINFO*) &BIH,
                             DIB_PAL_COLORS,
                             (void**)bits,
                             NULL,
                             0);

    ASSERT(*hbm);
    ASSERT(*bits);

    // Select the new bitmap into the buffer DC.
    if (*hbm)
    {
        SelectObject(hdc,*hbm);
    }
     
}


unsigned char *ChargeBmpDansSprite24(const char *nomFichier)		{
	FILE *f;
	unsigned char *ptr, *bloc;
	int i, tx=0, ty=0, x, y;
	WORD v;

	f=fopen(nomFichier,"rb");

	if (!f)		{
		erreurFatale("Impossible de charger un des fichiers bitmap.");
		return NULL;
	}

	for (i=0;i<=26;i++)	{
		fread(&v,sizeof(WORD),1,f);		//Un mot, c'est deux octets

		if (i==9)  tx=v;
		if (i==11) ty=v;
	}

	bloc=(unsigned char *)malloc(tx*ty*3);

	for (y=ty-1;y>=0;y--)		{
		ptr=bloc+y*tx*3;
		for (x=0;x<tx*3;x++)		{
			*ptr++=fgetc(f);
		}
	}
	fclose(f);

	return bloc;
}

#define EffaceEcran()	memset(Bits,0,LARG*HAUT*3)

void ColoreCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	register unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*(ptr++)=bleu;
			*(ptr++)=vert;
			*(ptr++)=rouge;
		}
	}
}

void AdditionneCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;
	
	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*ptr>=255-bleu)			*ptr=255;
			else						*ptr+=bleu;
			ptr++;
			if (*ptr>=255-vert)			*ptr=255;
			else						*ptr+=vert;
			ptr++;
			if (*ptr>=255-rouge)		*ptr=255;
			else						*ptr+=rouge;
			ptr++;
		}
	}
}

void SoustraitCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;
	
	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*ptr<=bleu)				*ptr=0;
			else						*ptr-=bleu;
			ptr++;
			if (*ptr<=vert)				*ptr=0;
			else						*ptr-=vert;
			ptr++;
			if (*ptr<=rouge)			*ptr=0;
			else						*ptr-=rouge;
			ptr++;
		}
	}
}

void MasqueCadre(int x0, int y0, int l, int h, int couleur, register int niveau)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	register int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (bleu)
				*ptr=(bleu*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
			if (vert)
				*ptr=(vert*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
			if (rouge)
				*ptr=(rouge*niveau-(niveau-255)*(*ptr))/255;
			ptr++;
		}
	}
}

void TransCadre(int x0, int y0, int l, int h, int couleur, register unsigned char niveau)	{
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;
	int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;
	int nv=niveau-255, factb=bleu*niveau, factv=vert*niveau, factr=rouge*niveau;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr=(factb-nv*(*ptr))/255;
			ptr++;
			*ptr=(factv-nv*(*ptr))/255;
			ptr++;
			*ptr=(factr-nv*(*ptr))/255;
			ptr++;
		}
	}
}

//Mouais... rapide entre guillemets quoi! Elle limine la fonction de pixels transparents et copie plus rapidement
void SpriteRapide(short x0, short y0, short l, short h, unsigned char *sprite)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, tmp;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			tmp=*(ptr+3);
			*(long*)ptr=*(long*)sprite;
			ptr+=3;
			sprite+=3;
		}
		*(ptr)=tmp;
		sprite+=a;
	}

}

void Sprite(short x0, short y0, short l, short h, unsigned char *sprite)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
			*ptr=*sprite++;
			ptr++;
		}
		sprite+=a;
	}

}

void TransSprite(short x0, short y0, short l, short h, unsigned char *sprite, register unsigned char niveau)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, nv=255-niveau;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
			*(ptr++)=((*ptr)*nv+niveau*(*sprite++))/255;
		}
		sprite+=a;
	}

}

void AdditionneSprite(short x0, short y0, short l, short h, unsigned char *sprite)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite+=3;
				ptr+=3;
				continue;
			}
			if (*ptr+*sprite>=255)		*ptr=255;
			else						*ptr+=*sprite;
			ptr++, sprite++;
			if (*ptr+*sprite>=255)		*ptr=255;
			else						*ptr+=*sprite;
			ptr++, sprite++;
			if (*ptr+*sprite>=255)		*ptr=255;
			else						*ptr+=*sprite;
			ptr++, sprite++;
		}
		sprite+=a;
	}

}
void SpritePal(short x0, short y0, short l, short h, unsigned char *sprite, unsigned char *palette)		{
	int x, y, a=0;
	register unsigned char *bits=Bits+LARG_BUF*3*HAUT_BUF, *ptr, *pal;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*3*y-3*(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite)
				pal=palette+3*(*sprite++);
			else	{
				sprite++;
				ptr+=3;
				continue;
			}
			*ptr=*pal++;
			ptr++;
			*ptr=*pal++;
			ptr++;
			*ptr=*pal++;
			ptr++;
		}
		sprite+=a;
	}

}


#define DessTexte(x,y,texte)	TextOut(hdcImage,x,y,texte,strlen(texte))

void DessLigne(int x0, int y0, int x1, int y1)		{
	x0+=CLIP_X0;
	y0+=CLIP_Y0;
	x1+=CLIP_X0;
	y1+=CLIP_Y0;
	MoveToEx(hdcImage,x0,y0,NULL);
	LineTo(hdcImage,x1,y1);
}

void DessTriangle(int x0, int y0, int x1, int y1, int x2, int y2)		{
	POINT triangle[3];

	triangle[0].x=x0+CLIP_X0;
	triangle[0].y=y0+CLIP_Y0;
	triangle[1].x=x1+CLIP_X0;
	triangle[1].y=y1+CLIP_Y0;
	triangle[2].x=x2+CLIP_X0;
	triangle[2].y=y2+CLIP_Y0;

	Polygon(hdcImage,triangle,3);
}

