//Structures
typedef struct		{
	int angle;
	int type;
	int couleur;
	float x,y;
} BULLE;

typedef struct		{
	int angle, angleChoisi;
	int bulleChargee;
	int prochBulle;
	BULLE *bulleLiee;
} CANON;

typedef struct		{
	int type;
	int x,y;
	int couleur;
} BULLEMORTE;

//Enumrations (constantes)
enum codeTouches {TESPACE=32, TGAUCHE=37, THAUT=38, TDROITE=39, TBAS=40};
enum codeBulles  {BAUCUNE=0, BROUGE=1, BORANGE=2, BJAUNE=3, BVERTE=4, BBLEUE=5, BVIOLETTE=6, BBLANCHE=7, BNOIRE=8};
enum codeLancers {PASBULLE=0, LANCEE=1, NORMALE=2, ENNEMIE=3};
enum codeMorts   {FAMILLE=1, TOMBE=2};
enum modesJeu    {MODE_AUCUN=0, MODE_1J_PUZZLE, MODE_1J_LIBRE, MODE_2J_SEUL, MODE_2J_CHALLENGE, MODE_2J_ORDI, MODE_2J_RESEAU};
enum modesJoueur {MODEJ_NORMAL,MODEJ_GAMEOVER};

//Dclarations (globales)
CANON canonStd[3];
BULLE bulles[3][50];
BULLEMORTE bullesMortes[3][50];
unsigned char touches[256]={0};
unsigned char interdit[3][256]={FALSE};
int compteur=0;
unsigned char *bitsImg;
int Dbug[10], listeGble[10];
int bubble=0;						//Nombre de bulles ptes (pour ventuellement l'afficher dans le score)
int score[3], nBulles[3];
int nBullesMortes[3], tempsBullesMortes[3];
int offset_pL[3];
int nCoups[3], modeJoueur[3];
int nTrames=0, tempsJeu[3], tempsGameOver[3];
#define offset_premLigne offset_pL[J]

int GereFamilles(int x,int y,int num);
int GereBulle(BULLE *bulle);

//(R)Initialise les variables du jeu
void InitVars(int J)		{
	int i,j;

	score[J]=nBulles[J]=0;
	nBullesMortes[J]=tempsBullesMortes[J]=0;
	canonStd[J].angle=90;
	canonStd[J].bulleChargee=BAUCUNE;
	canonStd[J].prochBulle=(rand()%8)+1;
	canonStd[J].bulleLiee=NULL;
	canonStd[J].angleChoisi=-1;
	memset(bulles,0,sizeof(BULLE)*50);

	memset(mat[J],BAUCUNE,sizeof(mat[J]));

	if (J==0)		{
		for (j=0;j<1;j+=2)		{
			for (i=0;i<15;i+=2)
				map(i,j)=(rand()%8)+1;
			for (i=1;i<15;i+=2)
				map(i,j+1)=(rand()%8)+1;
		}
		for (i=0;i<15;i+=2)
			map(i,j)=(rand()%8)+1;
	}
	else
		memcpy(mat[1],mat[0],sizeof(mat[1]));
	offset_premLigne=1;
	score[J]=0;
	tempsJeu[J]=0;
	modeJoueur[J]=MODEJ_NORMAL;
	tempsGameOver[J]=0;
}

//Gre les tches standardes  propos du canon
void GestionCanon(CANON *canonStd)		{
	if (canonStd->bulleChargee==BAUCUNE && !bulles[J][0].type)		{		//Le canon est vide
		//On va y charger une nouvelle bulle
		canonStd->bulleChargee=canonStd->prochBulle;
		canonStd->prochBulle=(rand()%8)+1;
	}
}

//Cre une bulle et en retourne l'adresse
BULLEMORTE *CreeBulleMorte(int x, int y, int type, int couleur)		{
	BULLEMORTE *pBulle=&bullesMortes[J][nBullesMortes[J]++];
	pBulle->x=x;
	pBulle->y=y;
	pBulle->type=type;
	pBulle->couleur=couleur;
	return pBulle;
}

//Cre une bulle et en retourne l'adresse
BULLE *CreeBulle(int angle, int couleur, int type, float x, float y)		{
	BULLE *pBulle=&bulles[J][0];
	pBulle->angle=angle;
	pBulle->couleur=couleur;
	pBulle->type=type;
	pBulle->x=x;
	pBulle->y=y;
	return pBulle;
}

//Gre les touches et modifie le canon en consquence
void GereTouchesCanon(CANON *canonStd)		{
	int pas=1;

	if (modeJoueur[J]==MODEJ_GAMEOVER)
		return;

	if (touches[16])		{
		canonStd->angle-=canonStd->angle%2;
		pas=2;
	}

	if (touches[THAUT])		{
		if (canonStd->angle>90)
			canonStd->angle-=pas;
		else if (canonStd->angle<90)
			canonStd->angle+=pas;
	}
	if (touches[TBAS])		{
		if (canonStd->angle>90 && canonStd->angle<170)
			canonStd->angle+=pas;
		else if (canonStd->angle<90 && canonStd->angle>10)
			canonStd->angle-=pas;
	}

	if (touches[TGAUCHE] && canonStd->angle<170)
		canonStd->angle+=pas;
	if (touches[TDROITE] && canonStd->angle>10)
		canonStd->angle-=pas;

	if (touches[TESPACE])		{
		if (!interdit[J][TESPACE] && !bulles[J][0].type)		{
			//Pas interdit la touche ET la boule 0 non-occupe (cd rien en train de tirer)
			BULLE *pBulle;					//La bulle retourne par CreeBulle devra tre place dans le canon
			pBulle=CreeBulle(canonStd->angle,canonStd->bulleChargee,LANCEE,64,176);
			canonStd->bulleChargee=BAUCUNE;
			canonStd->bulleLiee=pBulle;


			//UNIQUEMENT POUR LE DEBOGUAGE! ENLEVER ENSUITE!
			memcpy(mat2,mat,sizeof(mat2));
		}
		interdit[J][TESPACE]=TRUE;
	}
	else		{
		interdit[J][TESPACE]=FALSE;
	}

	if (touches[17])
		touches[TGAUCHE]=touches[THAUT]=touches[TDROITE]=touches[TBAS]=0;
}

//Gre les tches standardes  propos du canon
void GestionIA(CANON *canonStd)		{
	if (canonStd->bulleChargee==BAUCUNE && !bulles[J][0].type)		{		//Le canon est vide
		//On va y charger une nouvelle bulle
		canonStd->bulleChargee=canonStd->prochBulle;
		canonStd->prochBulle=(rand()%8)+1;
	}
}

int EssaieMouvement(int angle, int couleur)		{
	int valeur;
	BULLE *pBulle;
	pBulle=CreeBulle(angle,couleur,LANCEE,64,176);
	while(1)		{
		valeur=GereBulle(pBulle);
		if (valeur!=-2)
			return valeur;
	}
}

void Reflechit(CANON *canonStd)	{
	BULLE *pBulle;					//La bulle retourne par CreeBulle devra tre place dans le canon
	int bub;
	int i,val,a=canonStd->angleChoisi,b;
	static int maximum, meilleurangle, rechercheFinie, nbMax;

	if (modeJoueur[J]==MODEJ_GAMEOVER)
		return;
		
	if (nCoups[1]==10)
		return;

	if (a<=-1 && a>=-15)		{
		bub=bubble;

		offset_pL[2]=offset_pL[1];

		RegleJoueur(3);				//Joueur imaginaire. Juste pour les tests...

		if (a==-1)
			maximum=0;

		a=-a;
		a--;
		a*=5;
		for (i=a;i<a+5;i+=1)		{
			memcpy(mat[2],mat[1],sizeof(mat[2]));
			val=EssaieMouvement(90-i,canonStd->bulleChargee);
			if (val>maximum)		{
				maximum=val;
				meilleurangle=90-i;
			}
			memcpy(mat[2],mat[1],sizeof(mat[2]));
			val=EssaieMouvement(90+i,canonStd->bulleChargee);
			if (val>maximum)		{
				maximum=val;
				meilleurangle=90+i;
			}
		}
		RegleJoueur(2);
		bubble=bub;
		canonStd->angleChoisi--;
		rechercheFinie=0;
	}
	else if (a==-16 || a==-17)		{
		RegleJoueur(3);
		a=-a;
		a-=16;

		for (i=5*a;i<5*a+5 && !rechercheFinie;i+=1)		{
			memcpy(mat[2],mat[1],sizeof(mat[2]));
			if (meilleurangle>90)
				val=EssaieMouvement(meilleurangle+i,canonStd->bulleChargee);
			else
				val=EssaieMouvement(meilleurangle-i,canonStd->bulleChargee);

			if (val<maximum)
				rechercheFinie=1;
			else
				nbMax=i;
		}

		RegleJoueur(2);
		canonStd->angleChoisi--;
	}
	else if (a==-18)		{
		if (meilleurangle<=90)
			meilleurangle-=nbMax/2;
		else
			meilleurangle+=nbMax/2;
		canonStd->angleChoisi=meilleurangle;
		RegleJoueur(3);
	}
	else		{
		if (canonStd->angle<canonStd->angleChoisi)
			canonStd->angle++;
		else if (canonStd->angle>canonStd->angleChoisi)
			canonStd->angle--;
		else if (canonStd->angle==canonStd->angleChoisi)		{
			pBulle=CreeBulle(canonStd->angle,canonStd->bulleChargee,LANCEE,64,176);
			canonStd->bulleChargee=BAUCUNE;
			canonStd->bulleLiee=pBulle;
			canonStd->angleChoisi=-1;
		}
	}

	//Mthode de base (non-dcoupe)
/*	if (canonStd->angleChoisi==-1 && nBullesMortes[J]==0)		{
		bub=bubble;
		RegleJoueur(3);				//Joueur imaginaire. Juste pour les tests...
		maximum=0;
		for (i=1;i<80;i+=1)		{
			memcpy(mat[2],mat[1],sizeof(mat[2]));
			val=EssaieMouvement(90-i,canonStd->bulleChargee);
			if (val>maximum)		{
				maximum=val;
				canonStd->angleChoisi=90-i;
			}
			memcpy(mat[2],mat[1],sizeof(mat[2]));
			val=EssaieMouvement(90+i,canonStd->bulleChargee);
			if (val>maximum)		{
				maximum=val;
				canonStd->angleChoisi=90+i;
			}
		}
		RegleJoueur(3);				//Joueur imaginaire. Juste pour les tests...
		memcpy(mat[2],mat[1],sizeof(mat[2]));
		EssaieMouvement(canonStd->angleChoisi,canonStd->bulleChargee);
		RegleJoueur(2);
		bubble=bub;
	}
	else		{
		if (canonStd->angle<canonStd->angleChoisi)
			canonStd->angle++;
		else if (canonStd->angle>canonStd->angleChoisi)
			canonStd->angle--;
		else if (canonStd->angle==canonStd->angleChoisi)		{
			pBulle=CreeBulle(canonStd->angle,canonStd->bulleChargee,LANCEE,72,176);
			canonStd->bulleChargee=BAUCUNE;
			canonStd->bulleLiee=pBulle;
			canonStd->angleChoisi=-1;
		}
	}*/
}

#define BOUNDS_COLLIDE(x0,y0,x1,y1,l,h)		(x1-x0>=-l && x1-x0<=l && y1-y0>=-h && y1-y0<=h)

typedef int ANGLE;

//Retourne l'angle donn lorsqu'un objet d'angle alpha cogne contre une paroi d'angle bta. Je l'avais crite pour un flipper  la base...
ANGLE rebondit(ANGLE alpha, ANGLE beta)		{
	return (360-(alpha-beta)+beta)%360;
}

//Ma propre routine (semble plus adapte, 'faudra faire des tests)
/*void RecherchePosition(int *posX, int *posY)		{
	int pos_x, pos_y, offset, x=(*posX)-8, y=(*posY)-8;
	pos_y=(y+7)/14;
	offset=pos_y%2;
	if (offset_premLigne==0)
		offset=1-offset;

	if (offset)		{
		pos_x=((x/16)*2)+1;
		if (pos_x>=15)
			pos_x=13;
	}
	else		{
		pos_x=((x+8)/16)*2;
		if (pos_x>=15)
			pos_x=14;
	}
	*posX=pos_x;
	*posY=pos_y;
}*/

//Pas ma routine. A voir...
void RecherchePosition(int *posX, int *posY)		{
	int pos_x,pos_y,offset,xx;
	int x=(*posX)-8, y=(*posY)-8;

	// (x,y) => coordinates of the stopped bubble

	pos_y=(y)/14+(y%14)/7;
	offset=pos_y%2;
	if (offset_premLigne==0)
		offset=1-offset;
	xx=x-8*offset;

	// (pos_x,pos_y) => its position in the 'storage' array
	pos_x=xx/16+(xx%16)/8;
	pos_x=2*pos_x+offset;

	if (pos_x==-1)
		pos_x+=2;
	if (pos_x==15)
		pos_x-=2;

	*posX=pos_x;
	*posY=pos_y;
}


unsigned char miniEcran[320*240];

void SpriteNB(int x0, int y0, int l, int h, unsigned char *sprite)		{
	unsigned char *ptr;
	int y,ll;
	for (y=y0;y<y0+h;y++)	{
		ptr=miniEcran+320*y+x0;
		for (ll=l;ll;ll--, sprite++, ptr++)
			if (*sprite)
				*ptr=1;
	}
}

/*unsigned char masqueBulle[16*16]=		{
	0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
	0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,
};*/

/*unsigned char masqueBulle[16*16]=		{
	0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,
	0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,
	0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,
	0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,
};*/

unsigned char masqueBulle[16*16]=		{

	0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,
	0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,
	0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
	0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,
	0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,
};

//Dessine un tableau masque monochrome pour la dtection de collisions
void DessTableauNB()		{
	int i,j;
	memset(miniEcran,0,sizeof(miniEcran));
	for (j=0;j<13;j++)		{
		for (i=0;i<15;i++)		{
			if (map(i,j))
				SpriteNB(8+8*i,8+14*j,16,16,masqueBulle);
		}
	}
}

BOOL TesteCollision(int x0, int y0, unsigned char *sprite, int l, int h)		{
	unsigned char *ptr;
	int y,ll;
	for (y=y0;y<y0+h;y++)	{
		ptr=miniEcran+320*y+x0;
		for (ll=l;ll;ll--, sprite++, ptr++)
			if (((*sprite)+(*ptr))==2)
				return 1;
	}
	return 0;
}

#define OPTIMISATION

int GereBulle(BULLE *bulle)		{
	int posX, posY, valeur;
#ifdef OPTIMISATION
	int pX, pY, collision, i, j;
#endif
	float vx, vy;

	if (bulle->type==LANCEE)		{
		compteur++;
		posX=(int)bulle->x, posY=(int)bulle->y;
		if (BOUNDS_COLLIDE(posX,posY,0,posY,8,16) || BOUNDS_COLLIDE(posX,posY,136,posY,16,16))
			bulle->angle=rebondit(bulle->angle,90);
		if (BOUNDS_COLLIDE(posX,posY,posX,0,16,8))
			bulle->angle=rebondit(bulle->angle,0);
		vx=(float)(1.0*cos((bulle->angle*PI)/180.0)), vy=(float)(1.0*sin((bulle->angle*PI)/180.0));
		bulle->x+=vx, bulle->y-=vy;

		if (bulle->y>=169 && bulle->angle>180)		{		//Bulle arrive au fond...
			bulle->type=PASBULLE;							//On la dtruit
			return -3;
		}

		/*
		pY=((int)bulle->y-8)/14;
		pX=((int)bulle->x-16)/8;

		collision=0;
		for (i=-1;i<=2;i++)
			for (j=-1;j<=1;j++)
				if (map(pX+i,pY+j))		{
					if ((j==-1 && ((int)bulle->y-8)%14>0) || (i==2 && ((int)bulle->x-24)%16==0))
						continue;
					collision=1;
				}

		if (collision)		{
			posX=(int)bulle->x;
			posY=(int)bulle->y;
			RecherchePosition(&posX,&posY);
			map(posX,posY)=bulle->couleur;
			GereFamilles(posX,posY,bulle->couleur-1);
			bulle->type=0;
		}*/
#ifdef OPTIMISATION
		pY=((int)bulle->y-8)/14;
		pX=((int)bulle->x-8)/8;
		collision=0;
		for (i=-1;i<=2;i++)
			for (j=-1;j<=1;j++)
				if (map(pX+i,pY+j))
					collision=1;

		if (collision)
			if (TesteCollision((int)bulle->x,(int)bulle->y,masqueBulle,16,16))		{
#else
		if (TesteCollision((int)bulle->x,(int)bulle->y,masqueBulle,16,16))		{
#endif
//				posX=(int)bulle->x;
//				posY=(int)bulle->y;
				RecherchePosition(&posX,&posY);
				map(posX,posY)=bulle->couleur;
				valeur=GereFamilles(posX,posY,bulle->couleur-1);
				if (J==2)		{
					if (posY>=7)
						valeur--;
				}
				else		{
					if (valeur>=3)		{
						nBulles[J]+=valeur;
						score[J]+=10*(int)pow(2,valeur-3);
					}
				}
				bulle->type=0;
				if (J!=2)
					nCoups[J]++;
				return valeur;
		}
	}
	return -2;
}

//Gere les bulles disponibles selon leur type
void GereBulles(BULLE *bulles)		{
	int i,j;
	for (i=0;bulles[i].type;i++)		{
		for (j=0;j<4;j++)
			GereBulle(&bulles[i]);
	}
}



//Contrle s'il y a des bulles qui ne sont plus attaches  rien et les fait tomber
void GereBullesATomber()
{
	// Table des coordonnes  utiliser pour trouver les bulles autour de la boule 'B'
	//    6   1
	//  5   B   2
	//    4   3
	int voisinX[6]={-1,1,2,1,-1,-2};
	int voisinY[6]={-1,-1,0,1,1,0};

	//Map temporaire pour les contrles
	//L'algo est le suivant:
	//On part du sommet (toute la premire ligne est marque comme attache)
	//Puis on remonte. Toutes les bulles qui sont attaches  d'autres bulles elles-aussi
	//marques comme attaches le deviennent galement.
	//A la fin, toutes les bulles non-marques comme attaches vont tomber.

	int attachees[12][15];

	COORD coordonnees[500];

	int xx,yy,xxx,yyy,i,j,k;			//Variables temporaires ( noms douteux...)

	int nombre=1;						//Nombre de boules  contrler dans le voisinage
	int numero=1;						//Numro de la boule courante

	coordonnees[0].X=0;
	coordonnees[0].Y=0;

	// Initialise la liste des boules attaches  "aucune"
	for (i=0;i<15;i++)
		for (j=0;j<12;j++)
			attachees[j][i]=0;


	for (k=1-offset_premLigne;k<15;k+=2)
	{
		if (map(k,0)==0)
			continue;

		attachees[0][k]=1;					//Met la premire range  "attache"

		// Coordonnes des bulles avec lesquelles nous travaillons
		xx=k;
		yy=0;

		while(1)		{
			// On regarde les 6 bulles avoisinantes en utilisant les tableaux
			for (i=0;i<6;i++)			{
				// xxx,yyy => coordinates of one of the 6 'possible'
				// surrounding bubbles
				xxx=voisinX[i]+xx;
				yyy=voisinY[i]+yy;

				//S'il:
				//-N'y a pas de bulle
				//-On est hors de l'cran
				//-La boule est dj marque comme attache
				//=> on passe notre chemin
				if (xxx<0 || xxx>=15 || yyy<0 || yyy>11 ||
				attachees[yyy][xxx]!=0 || map(xxx,yyy)==0)
					continue;

				//Cette bulle est attache.
				attachees[yyy][xxx]=1;

				//Il y aura une autre bulle  contrler plus tard
				//On stoque ses coordonnes.
				coordonnees[nombre].X=xxx;
				coordonnees[nombre].Y=yyy;
				nombre++;
			}
			//Toutes les bulles ont-elles t contrles?
			if (nombre==numero)
				break;
			//On s'occupe de la prochaine bulle  contrler
 			xx=coordonnees[numero].X;
			yy=coordonnees[numero].Y;
			numero++;
		}

	}

	//Maintenant on vrifie si des bulles n'ont pas t marques comme attaches
	//Et on les fait tomber...

	for (i=0;i<15;i++)
		for (j=11;j>-1;j--)
		{
			if (map(i,j)!=0 && attachees[j][i]==0)
			{
				CreeBulleMorte(8+i*8,8+j*14,TOMBE,map(i,j));
				//La balle n'est plus l. Au revoir!
			  	map(i,j)=0;
				//Le nombre de bulles ptes incrmente
				bubble++;
			}
		}

}



//Cette routine contrle s'il y a trois bulles ou plus ensembles (une famille quoi)
//Et les limine. Aussi elle fera appel  GereBullesATomber si c'est le cas.
int GereFamilles(int x,int y,int num)
{
	int bub=bubble;
	// Table des coordonnes  utiliser pour trouver les bulles autour de la boule 'B'
	//    6   1
	//  5   B   2
	//    4   3
	int voisinX[6]={-1,1,2,1,-1,-2};
	int voisinY[6]={-1,-1,0,1,1,0};

	//Tableau utilis pour voir si on a dj test une bulle;
	//Si un lment vaut 0 => Position pas encore teste
	//Si un lment vaut 1 => Position dj teste mais mauvaise
	//Si un lment vaut 2 => Une bulle de la bonne couleur s'y trouve
	int controle[12][15];

	//Coordonnes des bulles avoisinantes qu'il faudra aussi contrler
	COORD coordonnees[500];

	int xx=x,yy=y,xxx,yyy,i,j;
	int nombre=1;						//Nombre de boules  contrler dans le voisinage
	int numero=1;						//Numro de la boule courante

	coordonnees[0].X=x;
	coordonnees[0].Y=y;

	//Initialise le tableau
	for (i=0;i<15;i++)
		for (j=0;j<12;j++)
			controle[j][i]=0;


	controle[y][x]=2;

	while(1)		{
		//xx,yy => Coordonnes de la bulle avec laquelle on travaille

		//Contrler les 6 boules avoisinantes...
		for (i=0;i<6;i++)		{
			// xxx,yyy => Coordonnes de la bulle que l'on va tester
  			xxx=voisinX[i]+xx;
			yyy=voisinY[i]+yy;

			//Pas une boule valide, hors de l'cran ou dj controle?
			if (xxx<0 || xxx>14 || yyy<0 || yyy>11 ||
			controle[yyy][xxx]!=0)
				continue;

			//Cette position a t controle...
			controle[yyy][xxx]=1;

			//Si cette boule n'a pas la bonne couleur -> on s'arrte ici
			if (map(xxx,yyy)!=num+1)
				continue;

			//C'est une bonne couleur
			controle[yyy][xxx]=2;

			//Il faudra contrler si cette bulle a elle-aussi des voisins
			//de la bonne couleur
			coordonnees[nombre].X=xxx;
			coordonnees[nombre].Y=yyy;
			nombre++;
		}

		//Toutes les bulles ont t controlles?
		if (nombre==numero)
			break;

		//Sinon on s'occupe de la prochaine bulle  contrler
		xx=coordonnees[numero].X;
		yy=coordonnees[numero].Y;
		numero++;
	}


	//Y'a-t-il au moins trois bulles identiques se touchant?
	if (nombre>=3)		{
		nBullesMortes[J]=0;					//Efface toutes les bulles mortes
		//Augmente le nombre de bulles eues
		bubble+=nombre;

		//Toutes les bulles dont on a stoqu les coordonnes doivent tre effaces
  		for (i=0;i<nombre;i++)		{
	  		xx=coordonnees[i].X;
	   		yy=coordonnees[i].Y;
			CreeBulleMorte(8+xx*8,8+yy*14,FAMILLE,map(xx,yy));
			map(xx,yy)=0;
			tempsBullesMortes[J]=255;
		}
		//Maintenant il ne reste plus qu' contrler si des boules ne sont plus
		//attaches  rien et  les faire tomber...
		GereBullesATomber();
	}

	//Retourne le nombre de bulles ptes
	if (bub!=bubble)
		return bubble-bub;
	else
		return nombre;
}

void GereBullesMortes(BULLEMORTE *bullesMortes)		{
	int i,j,k=0;

	tempsBullesMortes[J]-=6;

	//Les bulles ont maintenant disparu car compltement transparentes
	if (tempsBullesMortes[J]<=0)
		nBullesMortes[J]=0;

	k=nBullesMortes[J];
	for (i=0;i<nBullesMortes[J];i++)		{
		if (bullesMortes[i].type==TOMBE)		{
			k=i;
			break;
		}
	}

	for (i=0;i<nBullesMortes[J];i++)		{
		if (bullesMortes[i].type==FAMILLE)		{
			if (i<k/2)
				j=-1;
			else
				j=1;
			if (tempsBullesMortes[J]>=192)
				bullesMortes[i].y-=2, bullesMortes[i].x+=3*j;
			else if (tempsBullesMortes[J]>=128)
				bullesMortes[i].x+=2*j;
			else if (tempsBullesMortes[J]>=64)
				bullesMortes[i].y+=2, bullesMortes[i].x+=j;
			else
				bullesMortes[i].y+=4, bullesMortes[i].x+=j;
		}
		else if (bullesMortes[i].type==TOMBE)
			bullesMortes[i].y+=5;
	}
}

void GereFinale()		{
	int i,j;
	static int compteur=0;

	for (i=0;i<15;i++)
		for (j=11;j<=15;j++)
			if (map(i,j))
				modeJoueur[J]=MODEJ_GAMEOVER;

	if (modeJoueur[J]==MODEJ_GAMEOVER)
		tempsGameOver[J]++;

	if (nCoups[J]>=10)		{
		if (compteur>=8)		{
			for (i=0;i<nBullesMortes[J];i++)
				bullesMortes[J][i].y+=14;
			for (i=12;i>0;i--)
				for (j=0;j<15;j++)
					map(j,i)=map(j,i-1);
			// init a new bubble row
			for (i=0;i<15;i+=2)
			{
				map(i+offset_premLigne,0)=(rand()%8)+1;
				map(i+1-offset_premLigne,0)=0;
			}
			offset_premLigne=1-offset_premLigne;
			nCoups[J]-=10;
			compteur=0;
		}
		else
			compteur++;
	}
}

//La procdure principale du jeu
void Jeu()		{

	nTrames++;

	if (nTrames%50==0)		{
		tempsJeu[0]++;
		tempsJeu[1]++;
	}

	//Joueur 1
	RegleJoueur(1);
	if (touches['9'])		{
		touches['9']=0;
		sprintf(str,"%i %i %i %i %i %i %i %i %i %i",Dbug[0],Dbug[1],Dbug[2],Dbug[3],Dbug[4],Dbug[5],Dbug[6],Dbug[7],Dbug[8],Dbug[9]);
		MessageBox(NULL,str,"Trace de dboguage",MB_ICONINFORMATION);
	}
	if (touches['0'])		{
		touches['0']=0;
		memcpy(mat,mat2,sizeof(mat));
	}

	GestionCanon(&canonStd[J]);
	GereTouchesCanon(&canonStd[J]);

	DessTableauNB();
	GereBulles(bulles[J]);
	GereBullesMortes(bullesMortes[J]);
	GereFinale();


	//Joueur 2
	RegleJoueur(2);
	DessTableauNB();

	if (mode==MODE_2J_SEUL)		{					//Mode deux joueurs contrl par un seul
		GestionCanon(&canonStd[J]);
		GereTouchesCanon(&canonStd[J]);
	}
	else if (mode==MODE_2J_CHALLENGE)		{		//Mode deux joueurs en Challenge avec l'adversaire contrl par l'ordi
		GestionIA(&canonStd[J]);
		if (canonStd[J].bulleChargee)
			Reflechit(&canonStd[J]);
		nCoups[0]=nCoups[1]=0;
	}
	else if (mode==MODE_2J_ORDI)		{			//Mode deux joueurs avec l'adversaire contrl par l'ordi
		GestionIA(&canonStd[J]);
		if (canonStd[J].bulleChargee)
			Reflechit(&canonStd[J]);
	}

	GereBulles(bulles[J]);
	GereBullesMortes(bullesMortes[J]);
	GereFinale();
}

#include "dessin.h"
